# class LLVM::Builder

- LLVM::Builder
- Reference
- Object

##
Defined in:

##
Constructors

- .new(unwrap : LibLLVM::BuilderRef)

##
Instance Method Summary

- #add(lhs, rhs, name = "")
- #add_handler(catch_switch_ref, handler)
- #alloca(type, name = "")
- #and(lhs, rhs, name = "")
- #ashr(lhs, rhs, name = "")
- #atomicrmw(op, ptr, val, ordering, singlethread)
- #bit_cast(value, type, name = "")
- #br(block)
- #build_catch_ret(pad, basic_block)
- #build_operand_bundle_def(name, values : Array(LLVM::Value))
- #call(func, arg : LLVM::Value, name : String = "")
- #call(func, name : String = "")
- #call(func, args : Array(LLVM::Value), name : String = "", bundle : LLVM::OperandBundleDef = LLVM::OperandBundleDef.null)
- #catch_pad(parent_pad, args : Array(LLVM::Value), name = "")
- #catch_switch(parent_pad, basic_block, num_handlers, name = "")
- #cmpxchg(pointer, cmp, new, success_ordering, failure_ordering)
- #cond(cond, then_block, else_block)
- #current_debug_location
- #exact_sdiv(lhs, rhs, name = "")
- #extract_value(value, index, name = "")
- #fadd(lhs, rhs, name = "")
- #fcmp(op, lhs, rhs, name = "")
- #fdiv(lhs, rhs, name = "")
- #fence(ordering, singlethread, name = "")
- #fmul(lhs, rhs, name = "")
- #fp2si(value, type, name = "")
- #fp2ui(value, type, name = "")
- #fpext(value, type, name = "")
- #fptrunc(value, type, name = "")
- #fsub(lhs, rhs, name = "")
- #gep(value, index : LLVM::Value, name = "")
- #gep(value, index1 : LLVM::Value, index2 : LLVM::Value, name = "")
- #gep(value, indices : Array(LLVM::ValueRef), name = "")
- #global_string_pointer(string, name = "")
- #icmp(op, lhs, rhs, name = "")
- #inbounds_gep(value, index : LLVM::Value, name = "")
- #inbounds_gep(value, indices : Array(LLVM::ValueRef), name = "")
- #inbounds_gep(value, index1 : LLVM::Value, index2 : LLVM::Value, name = "")
- #insert_block
- #int2ptr(value, type, name = "")
- #invoke(fn, args : Array(LLVM::Value), a_then, a_catch, bundle : LLVM::OperandBundleDef = LLVM::OperandBundleDef.null, name = "")
- #landing_pad(type, personality, clauses, name = "")
- #load(ptr, name = "")
- #load_volatile(ptr, name = "")
- #lshr(lhs, rhs, name = "")
- #mul(lhs, rhs, name = "")
- #not(value, name = "")
- #or(lhs, rhs, name = "")
- #phi(type, incoming_blocks : Array(LLVM::BasicBlock), incoming_values : Array(LLVM::Value), name = "")
- #phi(type, table : LLVM::PhiTable, name = "")
- #position_at_end(block)
- #ptr2int(value, type, name = "")
- #ret(value)
- #ret
- #sdiv(lhs, rhs, name = "")
- #select(cond, a_then, a_else, name = "")
- #set_current_debug_location(line, column, scope, inlined_at = nil)
- #set_metadata(value, kind, node)
- #sext(value, type, name = "")
- #shl(lhs, rhs, name = "")
- #si2fp(value, type, name = "")
- #srem(lhs, rhs, name = "")
- #store(value, ptr)
- #store_volatile(value, ptr)
- #sub(lhs, rhs, name = "")
- #switch(value, otherwise, cases)
- #to_unsafe : LibLLVM::BuilderRef
- #trunc(value, type, name = "")
- #udiv(lhs, rhs, name = "")
- #ui2fp(value, type, name = "")
- #unreachable
- #urem(lhs, rhs, name = "")
- #xor(lhs, rhs, name = "")
- #zext(value, type, name = "")

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(unwrap : LibLLVM::BuilderRef) #

##
Instance Method Detail

def add(lhs, rhs, name = "") #
def add_handler(catch_switch_ref, handler) #
def alloca(type, name = "") #
def and(lhs, rhs, name = "") #
def ashr(lhs, rhs, name = "") #
def atomicrmw(op, ptr, val, ordering, singlethread) #
def bit_cast(value, type, name = "") #
def br(block) #
def build_catch_ret(pad, basic_block) #
def build_operand_bundle_def(name, values : Array(LLVM::Value)) #
def call(func, arg : LLVM::Value, name : String = "") #
def call(func, name : String = "") #
def call(func, args : Array(LLVM::Value), name : String = "", bundle : LLVM::OperandBundleDef = LLVM::OperandBundleDef.null) #
def catch_pad(parent_pad, args : Array(LLVM::Value), name = "") #
def catch_switch(parent_pad, basic_block, num_handlers, name = "") #
def cmpxchg(pointer, cmp, new, success_ordering, failure_ordering) #
def cond(cond, then_block, else_block) #
def current_debug_location #
def exact_sdiv(lhs, rhs, name = "") #
def extract_value(value, index, name = "") #
def fadd(lhs, rhs, name = "") #
def fcmp(op, lhs, rhs, name = "") #
def fdiv(lhs, rhs, name = "") #
def fence(ordering, singlethread, name = "") #
def fmul(lhs, rhs, name = "") #
def fp2si(value, type, name = "") #
def fp2ui(value, type, name = "") #
def fpext(value, type, name = "") #
def fptrunc(value, type, name = "") #
def fsub(lhs, rhs, name = "") #
def gep(value, index : LLVM::Value, name = "") #
def gep(value, index1 : LLVM::Value, index2 : LLVM::Value, name = "") #
def gep(value, indices : Array(LLVM::ValueRef), name = "") #
def global_string_pointer(string, name = "") #
def icmp(op, lhs, rhs, name = "") #
def inbounds_gep(value, index : LLVM::Value, name = "") #
def inbounds_gep(value, indices : Array(LLVM::ValueRef), name = "") #
def inbounds_gep(value, index1 : LLVM::Value, index2 : LLVM::Value, name = "") #
def insert_block #
def int2ptr(value, type, name = "") #
def invoke(fn, args : Array(LLVM::Value), a_then, a_catch, bundle : LLVM::OperandBundleDef = LLVM::OperandBundleDef.null, name = "") #
def landing_pad(type, personality, clauses, name = "") #
def load(ptr, name = "") #
def load_volatile(ptr, name = "") #
def lshr(lhs, rhs, name = "") #
def mul(lhs, rhs, name = "") #
def not(value, name = "") #
def or(lhs, rhs, name = "") #
def phi(type, incoming_blocks : Array(LLVM::BasicBlock), incoming_values : Array(LLVM::Value), name = "") #
def phi(type, table : LLVM::PhiTable, name = "") #
def position_at_end(block) #
def ptr2int(value, type, name = "") #
def ret(value) #
def ret #
def sdiv(lhs, rhs, name = "") #
def select(cond, a_then, a_else, name = "") #
def set_current_debug_location(line, column, scope, inlined_at = nil) #
def set_metadata(value, kind, node) #
def sext(value, type, name = "") #
def shl(lhs, rhs, name = "") #
def si2fp(value, type, name = "") #
def srem(lhs, rhs, name = "") #
def store(value, ptr) #
def store_volatile(value, ptr) #
def sub(lhs, rhs, name = "") #
def switch(value, otherwise, cases) #
def to_unsafe : LibLLVM::BuilderRef #
def trunc(value, type, name = "") #
def udiv(lhs, rhs, name = "") #
def ui2fp(value, type, name = "") #
def unreachable #
def urem(lhs, rhs, name = "") #
def xor(lhs, rhs, name = "") #
def zext(value, type, name = "") #